Codeforces 847 B. Preparing for Merge Sort (二分)

网友投稿 749 2022-10-21

Codeforces 847 B. Preparing for Merge Sort (二分)

Codeforces 847 B. Preparing for Merge Sort (二分)

Description

Ivan has an array consisting of n different integers. He decided to reorder all elements in increasing order. Ivan loves merge sort so he decided to represent his array with one or several increasing sequences which he then plans to merge into one sorted array.Ivan represent his array with increasing sequences with help of the following algorithm.While there is at least one unused number in array Ivan repeats the following procedure:iterate through array from the left to the right;Ivan only looks at unused numbers on current iteration;if current number is the first unused number on this iteration or this number is greater than previous unused number on current iteration, then Ivan marks the number as used and writes it down.For example, if Ivan’s array looks like [1, 3, 2, 5, 4] then he will perform two iterations. On first iteration Ivan will use and write numbers [1, 3, 5], and on second one — [2, 4].Write a program which helps Ivan and finds representation of the given array with one or several increasing sequences in accordance with algorithm described above.

Input

The first line contains a single integer n (1 ≤ n ≤ 2·10^5) — the number of elements in Ivan’s array.The second line contains a sequence consisting of distinct integers a1, a2, …, an (1 ≤ ai ≤ 10^9) — Ivan’s array.

Output

Print representation of the given array in the form of one or more increasing sequences in accordance with the algorithm described above. Each sequence must be printed on a new line.

Examples input

51 3 2 5 4

Examples output

1 3 52 4

题意

找出所有不重叠不下降的子序列。

思路

有一种暴力的想法:我们可以在 O(n)

不过这佯的方法时间复杂度为 O(n2)

考虑用队列来存储所有不重叠不下降的子序列,对于已拓展出的 len

比如我们有 5,4,3,2,1,6,8,7,5

5,6,84,73,521

此时由所有队列尾部组成的序列为 8,7,5,2,1 ,对于即将加入的新数字 x ,如果在已有队列尾部可以找到一个编号最小且尾部小于等于 x 的索引,那么我们可以将 x

查找采用二分总时间复杂度为 O(n×logn)

AC 代码

#includeusing namespace std;const int maxn = 2e5+10;typedef __int64 LL;LL a[maxn];int n;deque top[maxn];int lower_update(int len,LL x) // 找一个编号最小且队列末尾元素小于 x 的索引{ int low = 0,high = len; while(low>1; if(*top[mid].rbegin()<=x) high = mid; else low = mid + 1; } if(high == len)return -1; return high;}void solve(){ int len = 0; for(int i=0; i>n; for(int i=0; i>a[i]; solve(); return 0;}

版权声明:本文内容由网络用户投稿,版权归原作者所有,本站不拥有其著作权,亦不承担相应法律责任。如果您发现本站中有涉嫌抄袭或描述失实的内容,请联系我们jiasou666@gmail.com 处理,核实后本网站将在24小时内删除侵权内容。

上一篇:YTU 2344: 先序遍历二叉树
下一篇:Angular Material- Angular 的 Material Design 风格框架
相关文章

 发表评论

暂时没有评论,来抢沙发吧~